/* www.sgm.siedlce.pl

Projekt wylacznie do wykorzystania na wlasny uzytek

Monitor pakietu LiPo 1S-3S z sygnalizacja spadku napiecia
pojedynczej celi ponizej zalozonego progu, dzialajacy na
kanale przepustnicy.
Dioda (LED13) sygnalizuje po podlaczeniu rozpoznana ilosc cel, po
uruchomieniu alarmu zapala sie na stale, jesli nie swieci,
to pakiet (zlacze balancerowe) nie jest podlaczony, lub podlaczony
nieprawidlowo. Prog alarmu ustawiany w wierszu deklaracji:
"const float Ua = 3.x;"
Jesli wszystkie cele powyzej progu, na wyjsciu RC jest to co
na wejsciu z odbiornika, jesli co najmniej jedna cela ponizej
minimum, na wyjsciu sygnal odpowiadajacy zeru przepustnicy,
lub polowa tej wartosci, w zaleznosci od ustawionej zwory ZW

wejscie RC (odbiornik, kanal przepustnicy) na Pin2
wyjscie RC(serwo, regler) na Pin12

pomiar czasu przy uzyciu biblioteki:
===================================================================================================
<eRCaGuy_Timer2_Counter.h> by Gabriel Staples
Visit my blog at http://electricrcaircraftguy.blogspot.com/
-My contact info is available by clicking the "Contact Me" tab at the top of my blog.
-Please support my work & contributions by buying something here: https://sites.google.com/site/ercaguystore1/
My original post containing this code can be found here: http://electricrcaircraftguy.blogspot.com/2014/02/Timer2Counter-more-precise-Arduino-micros-function.html
Written: 17 May 2014
Updated: 30 May 2014
===================================================================================================
  LICENSE & DISCLAIMER
  Copyright (C) 2015 Gabriel Staples.  All right reserved.
  
  ------------------------------------------------------------------------------------------------
  License: GNU Lesser General Public License Version 3 (LGPLv3) or later - https://www.gnu.org/licenses/lgpl.html
  ------------------------------------------------------------------------------------------------

  This file is part of eRCaGuy_Timer2_Counter.
  
  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program.  If not, see http://www.gnu.org/licenses/
===================================================================================================
*/

//dolaczenie biblioteki
#include <eRCaGuy_Timer2_Counter.h>

//deklaracje zmiennych 

volatile unsigned long pulse_start = 0; //zmienna dla get_count()  
volatile unsigned long pulse_uS = 0;    //zmienna na dlugosc impulsu kanalowego                              
int pulse_uSi;             //zmienna pomocnicza                                              

#include <Servo.h>         // dołączenie biblioteki 'servo'
Servo myservo;             // utworzenie obiektu do sterowania serwem 
                           // wyjscie na Pin 12
int ZW1;                   // zmienna na odczyt zworki ZW1
const int tnMarg = 40;     // margines zakresu cofnietego drazka

//***********************  wartosc "Default Pulse", odpowiadajaca zeru przepustnicy
int servoDP = 1500;        // 1500 auto, 1100 samolot
//int servoDP = 1100;
//***********************

byte CutMode;              // sposob odcieciecia w zal. od zworki              
int servoHT;               //zmienna na oblicz 1/2 przepustnicy
int servoTmp;
int servoP;                //zmienna na sygnal wyjsciowy servo
int buf1;                  //zmienne bufora impulsow
int buf2;

unsigned long t_start;

//deklaracje monitora napiecia
const int LED = 13;            // LED na Pin 13

byte LCell=0;                  // alarm tmp niskiego napiecia celi
byte MCell=0;                  // alarm staly niskiego napiecia celi
byte HT=0;                     // zmienna Half Throttle 
byte Toff=0;                   // zmienna na Throttle Off
byte nCell;                    // ilosc cel
int ReadA1;                    // stan we analog1
int ReadA2;                    // stan we analog2
int ReadA3;                    // stan we analog3
const int Ref = 5;             //napiecie odniesienia (5V)

//*******************   // tu mozna wstawic wartosci uzytkownika 
const float Ua = 3.3;   //prog alarmu 
//dzielniki("mnozniki")                               
const float x1 = 2.0;   //dzielnik celi 1   A1 --> 1k5/1k5
const float x2 = 2.0;   //dzielnik celi 2   A2 --> 3k3/3k3
const float x3 = 3.06;  //dzielnik celi 3   A3 --> 6k8/3k3
const float Vd = 0.65;  //napiecie diody
//*******************


float Vc1;              //zmierzone wartosci napiecia z dzielnika
float Vc2;
float Vc3;

float U1;               //obliczone napiecia celi
float U2;
float U3;

float U10;              //tymczasowe do zaokraglen
int Uint;
float Usum;



void setup()
{                
  //inicjalizacja LED (monitor pakietu)
  pinMode(LED, OUTPUT);
  digitalWrite(LED, LOW);
  //obsluga zworki trybu
  ZW1 = analogRead(0);
  delay(5);
  if (ZW1 <500){
   CutMode=0; // zamknieta
  } else {
   CutMode=1; // otwarta
  }
  
  
  //inicjalizacja modulu pomiaru RC
  servoP = servoDP;
  buf1 = servoDP;
  buf2 = servoDP;
  //inicjalizacja Timer2 wymagana przez biblioteke <eRCaGuy_Timer2_Counter.h>
  timer2.setup(); 
  //dolaczenie "myservo" do pin 12 
  myservo.attach(12);      
  myservo.writeMicroseconds(servoDP);
  delay(2000);
  //inicjalizacja portu szeregowego (prezentacja danych)
  //Serial.begin(115200); 
  //inicjalizacja przerwania 0 (pin 2, Arduino UNO)
  attachInterrupt(0, pulse_rising, RISING);
}


void loop()
{  
    
  ReadA1 = analogRead(1);
  delay(5);
  ReadA2 = analogRead(2);
  delay(5);
  ReadA3 = analogRead(3);
  delay(5);
  
  if (ReadA1 <10){
   nCell=0;
  } else { 
   if (ReadA2 <10){
    nCell=1;
   } else {
    if (ReadA3 <10){
     nCell=2;
    } else {
     nCell=3; 
    }     //if (ReadA3 <10) 
   }      //if (ReadA2 <10) 
  }       //if (ReadA1 <10)
  
  Vc1= Vd + (x1*Ref*ReadA1)/1024;
  Vc2= Vd + (x2*Ref*ReadA2)/1024;
  Vc3= Vd + (x3*Ref*ReadA3)/1024;
   
 switch (nCell) {  
  
  case 0:
    U1=4.2;
    U2=4.2;
    U3=4.2;
    digitalWrite(LED, LOW);

  break; // case 0
  
  case 1:
    U1=Vc1;
    U2=4.2;
    U3=4.2;
   if ((LCell==0) && (MCell==0)) { 
    digitalWrite(LED, HIGH);
    delay(100);
    digitalWrite(LED, LOW);
   } 
  break; // case 1
  
  case 2:
    U1=Vc1;
    U2=Vc2-Vc1;
    U3=4.2; 
   if ((LCell==0) && (MCell==0)) {
    digitalWrite(LED, HIGH);
    delay(100);
    digitalWrite(LED, LOW);
    delay(200);
    digitalWrite(LED, HIGH);
    delay(100);
    digitalWrite(LED, LOW);
   }
  break; // case 2

  case 3:
    U1=Vc1;
    U2=Vc2-Vc1;
    U3=Vc3-Vc2;
   if ((LCell==0) && (MCell==0)) {    
    digitalWrite(LED, HIGH);
    delay(100);
    digitalWrite(LED, LOW);
    delay(200);
    digitalWrite(LED, HIGH);
    delay(100);
    digitalWrite(LED, LOW);
    delay(200);
    digitalWrite(LED, HIGH);
    delay(100);
    digitalWrite(LED, LOW);
   }
  break; // case 3
  
  default: // jesli zadna z powyzszych
  break;   // default
 
 }
 
//zaokraglenia

  U10 = 10*U1;
  Uint = U10;
  if ((U10-Uint)>0.5) {
    U10 = ceil(U10);
  } else {
    U10 = floor(U10);
  }
  U1 = U10/10;
  
  U10 = 10*U2;
  Uint = U10;
  if ((U10-Uint)>0.5) {
    U10 = ceil(U10);
  } else {
    U10 = floor(U10);
  }
  U2 = U10/10;
  
  U10 = 10*U3;
  Uint = U10;
  if ((U10-Uint)>0.5) {
    U10 = ceil(U10);
  } else {
    U10 = floor(U10);
  }
  U3 = U10/10;
  
  Usum=U1+U2+U3;
  
  if ((U1<Ua) || (U2<Ua) || (U3<Ua)) {
   digitalWrite(LED, HIGH);         
   LCell = 1;         //  alarm tmp
   MCell = 1;         //  alarm staly (niezerowany)
   if (Toff == 0) {
    Toff = 1;           // odciecie gazu
    //t_start = millis();
   }
   delay (500);
  } else { 

   // digitalWrite(LED, LOW);
 
   LCell = 0;         // cele OK
   if (Toff == 2) {   // resetuj FS jesli drazek cofniety
    Toff = 0;
   }
  }  
  
  //wydruk zmierzonych wartości - do testowania,  
  /*  
  Serial.print("C1= ;");
  //Serial.print(Vc1,2);
  Serial.print(ReadA1);
  Serial.print("    C2= ;");
  //Serial.print(Vc2,2);
  Serial.print(ReadA2); 
  Serial.print("    C3= ;");
  //Serial.println(Vc3,2);
  Serial.println(ReadA3);

  Serial.print("C1= ;");
  Serial.print(Vc1,2);
  Serial.print("    C2= ;");
  Serial.print(Vc2,2);
  Serial.print("    C3= ;");
  Serial.println(Vc3,2);
  
  Serial.print("U1= ;");
  Serial.print(U1,2);
  Serial.print("    U2= ;");
  Serial.print(U2,2);
  Serial.print("    U3= ;");
  Serial.println(U3,2);
  
  Serial.println();
*/
 
 delay (1500);
 
} // koniec glownej petli

// obsluga przerwania (rising), poczatek impulsu
void pulse_rising() {
  pulse_start = timer2.get_count();
  attachInterrupt(0, pulse_falling, FALLING);
} //pulse_rising()



// obsluga przerwania (falling) 
void pulse_falling() {
  //dlugosc impulsu w microsec()
  pulse_uS = (timer2.get_count()-pulse_start)/2;
  pulse_uSi = pulse_uS;
  attachInterrupt(0, pulse_rising, RISING);
  timer2.reset();   //to chyba bardzo OK
  
  if (nCell == 0) { //brak pakietu na JST
   myservo.writeMicroseconds(servoDP); 
  
  } else {          //ilosc cel > 0, normalna oblsuga 
   //sprawdzenie czy z dozwolonego zakresu
   if ((pulse_uSi > 900) && (pulse_uSi < 2100)) {
     servoTmp = pulse_uSi + buf2 + buf1; 
     servoP = servoTmp / 3;
     buf2 = buf1;
     buf1 = servoP;

     if (CutMode==1) { // tryb odciecia
      switch (Toff) {  
       case 0: // normalny stan, zmierzona
        myservo.writeMicroseconds(servoP);   
       break; 
       case 1: // jest alarm
         myservo.writeMicroseconds(servoDP);
         // czy drazek cofniety
         if ((servoP > (servoDP-tnMarg)) && (servoP < (servoDP+tnMarg))){
          Toff = 2; 
         }  
       break; 
      }
     
     } else {     // tryb 1/2 gazu
      
      switch (MCell) {  
       case 0: // normalny stan, zmierzona
        myservo.writeMicroseconds(servoP);   
       break; 
       case 1: // jest alarm
        servoHT = servoP/2 + servoDP/2;
        myservo.writeMicroseconds(servoHT); 
       break; 
      }
       
     } // else  
     
   }   //if ((pulse_uSi >
  
  }   //if (nCell == 0) 

} //pulse_falling()
